! This file is part of SusHi.
! 
! It includes the input and output routines of SusHi.
! 
C-{{{ subroutine readinsushi

      subroutine readinsushi(fhflag,thdmcflag,extflag)

      implicit none

      logical fhflag,thdmcflag
      double precision mapreal8,xl(10),xu(10),acc
      integer ndm,ncall,itmx,nprn
      logical ifilein, ppcoll,extflag
      integer count1, count2, blockflag, rensbotc
      character blocks(20)*15, bltype*15

      include 'commons/common-inputoutput.f'
      !internal definitions
      include 'commons/common-slha.f'
      include 'commons/common-consts.f'
      include 'commons/common-vars.f'
      include 'commons/common-ren.f'
      include 'commons/common-quark.f'
      include 'commons/common-int.f'

      common /coll/ ppcoll
      common /bveg1/ xl,xu,acc,ndm,ncall,itmx,nprn

      inquire(file=jfilein,exist=ifilein)
      if(.not.ifilein)then
         write(6,*)'ERROR: FILE ',jfilein,' DOES NOT EXIST!'
         stop
      endif

      open(unit=12,file=jfilein)

      fhflag  = .false.
      thdmcflag = .false.

!     setting read-in-flags to false
      do count1=1,20
         blocks(count1) = ' '
      enddo
      do count1=1,100
         lsmassbo(count1)   = .false.
         lsmassfe1(count1)  = .false.
         lsmassfe2(count1)  = .false.
         lsminputs(count1)  = .false.
         lminpar(count1)    = .false.
         lsushipar(count1)  = .false.
      enddo
      do count1=1,60
         ldistribpar(count1) = .false.
         lextpar(count1)    = .false.
      enddo
      do count1=1,2
         do count2=1,2
            lstopmix(count1,count2) = .false.
         enddo
      enddo
      do count1=1,10
         lvegaspar(count1)      = .false.
         lyukawafac(count1)     = .false.
         lfourgen(count1)       = .false.
         lfeynhiggspar(count1)  = .false.
         lscalespar(count1)     = .false.
         lrenormbotpar(count1)  = .false.
         lrenormsbotpar(count1) = .false.
      enddo
      lslhaalpha = .false.

      !read in of the main parameters for SUSHI
      do count1=1,20
         blocks(count1) = ' '
      enddo
      blocks(1) = 'SUSHI'
      call readblocks(12,blocks)

      !SUSHI parameters
      model = sushipar(1)
      if (sushipar(2).eq.0) then
         pseudo = 0 !internal light Higgs
      else if (sushipar(2).eq.1) then
         pseudo = 1 !internal pseudoscalar
      else if (sushipar(2).eq.2) then
         pseudo = 2 !internal heavy Higgs
      else
         write(*,*) "Please specify the Higgs under consideration."
         stop
      endif

      if(sushipar(7).eq.1) then
         ew = 1
      else if (sushipar(7).eq.2) then
         ew = 2
      else
         ew = 0
      endif

      !---MSSM
      if (model.eq.1) then
      !looking for the block FEYNHIGGS
         bltype = 'FEYNHIGGS'
         call readslha(12,bltype,blockflag)

         if(blockflag.eq.1) then
            write(*,*)
     &"SusHi was called with the SLHA-block 'FEYNHIGGS':"
            write(*,*)
     &"Thus FeynHiggs is used for the calculation of SUSY"
            write(*,*)
     &"Higgs masses, mu and stop, sbottom masses/angles."
            fhflag  = .true.
         end if

      !read-in not dependent on FH-use
         do count1=1,20
            blocks(count1) = ' '
         enddo
         blocks(1) = 'SUSHI'
         blocks(2) = 'SMINPUTS'
         blocks(3) = 'MINPAR'
         blocks(4) = 'EXTPAR'
         blocks(5) = 'RENORMBOT'
         blocks(6) = 'RENORMSBOT'
         blocks(7) = 'FACTORS'
         call readblocks(12,blocks)

         !read-in dependent on FH-use
         do count1=1,20
            blocks(count1) = ' '
         enddo

         if (.not.fhflag) then
           !blocks(1) = 'SBOTMIX'
           !blocks(1) = 'STOPMIX'
            blocks(1) = 'ALPHA'
            blocks(2) = 'MASS'
            call readblocks(12,blocks)
         else
            blocks(1) = 'FEYNHIGGS'
            call readblocks(12,blocks)
            mssmpart = 4
            fieldren = 0
            tanbren = 0
            higgsmix = 2
            p2approx = 4
            looplevel = 2
            runningMT = 1
            botResum = 1
            tlCplxApprox = 0
         end if

      !---2HDM
      else if (model.eq.2) then
!     looking for the block 2HDMC
         bltype = '2HDMC'
         call readslha(12,bltype,blockflag)
         if(blockflag.eq.1) then
            write(*,*)
     &           "The input file contains the block '2HDMC':"
            write(*,*)
     &           "Thus 2HDMC is used for the calculation of the"
            write(*,*)
     &           "Higgs masses and the quark Yukawa couplings."
            thdmcflag  = .true.
         else
            thdmcflag  = .false.
         end if

      !read-in not dependent on 2HDMC-use:
         do count1=1,20
            blocks(count1) = ' '
         enddo
         blocks(1) = 'SUSHI'
         blocks(2) = 'SMINPUTS'
         blocks(3) = 'RENORMBOT'
         blocks(4) = 'FACTORS'
         call readblocks(12,blocks)

         !read-in dependent on 2HDMC-use
         do count1=1,20
            blocks(count1) = ' '
         enddo

         if (.not.thdmcflag) then
            blocks(1) = 'ALPHA'
            blocks(2) = 'MASS'
            blocks(3) = '2HDM'
            blocks(4) = 'MINPAR'
            call readblocks(12,blocks)
         else
            blocks(1) = '2HDMC'
            call readblocks(12,blocks)
         end if

      !---SM
      else if (model.eq.0) then

         bltype = 'FEYNHIGGS'
         call readslha(12,bltype,blockflag)

         if(blockflag.eq.1) then
            write(*,*)
     &"SusHi was called with the SLHA-block 'FEYNHIGGS' in the SM:"
            write(*,*)
     &"Thus FeynHiggs is used for the calculation of a Higgs mass,"
            write(*,*)
     &"however the Higgs is the SM Higgs!"
            fhflag  = .true.
         end if

         do count1=1,20
            blocks(count1) = ' '
         enddo
         if (.not.fhflag) then
            blocks(1) = 'SUSHI'
            blocks(2) = 'SMINPUTS'
            blocks(3) = 'MASS'
            blocks(4) = 'RENORMBOT'
            blocks(5) = 'FACTORS'
            call readblocks(12,blocks)
         else
            blocks(1) = 'SUSHI'
            blocks(2) = 'SMINPUTS'
            blocks(3) = 'MINPAR'
            blocks(4) = 'EXTPAR'
            blocks(5) = 'RENORMBOT'
            blocks(6) = 'RENORMSBOT'
            blocks(7) = 'FACTORS'
            blocks(8) = 'FEYNHIGGS'
            call readblocks(12,blocks)
            !standard flags for FH 2.9
            mssmpart = 4
            fieldren = 0
            tanbren = 0
            higgsmix = 2
            p2approx = 4
            looplevel = 2
            runningMT = 1
            botResum = 1
            tlCplxApprox = 0
!to be used for a fixed top mass within FH
!          runningMT = 0
         end if

      else
         write(*,105)
         write(*,*) 
     &"Error: We are sorry, but the specified model"
         write(*,*) 
     &"is no reasonable SusHi dish."
         write(*,105)
         stop
      end if

      !---Setting parameters

      !Standard model input parameters
      invAlfa=mapreal8(sminputs(1),lsminputs(1),'alpha_em undefined. ')
      GF = mapreal8(sminputs(2),lsminputs(2),'G_Fermi undefined. ')
      AlfasMZ=mapreal8(sminputs(3),lsminputs(3),'alphaSMZ undefined. ')
      MZ = mapreal8(sminputs(4),lsminputs(4),'Mz undefined. ')
      mbmb=mapreal8(sminputs(5),lsminputs(5),'bottom mass undefined. ')
      MT = mapreal8(sminputs(6),lsminputs(6),'top mass undefined. ')
      MS = -1
      MC = -1
      ME = -1
      MU = -1
      MD = -1
      MM = -1
      MS = -1
      ML = -1

      !calculating mW from mZ, GF and alpha_EM
      mW = dsqrt(0.25D0- (1.D0/invAlfa) * Pi / (dsqrt(2.D0)*GF*mZ*mZ))
      mW = mZ * mZ * (0.5D0 + mW) / 0.985D0
      mW = dsqrt(mW)

      !---MSSM
      if ((model.eq.1).or.((model.eq.0).and.fhflag)) then
         !Minpar parameters
         tanb = mapreal8(minpar(3),lminpar(3),'tanb undefined. ')

         !SUSY parameters from extpar or external masses
         if (.not.fhflag) then
            Mgl = mapreal8(dabs(extpar(3)),lextpar(3)
     &     ,'gluino mass undefined. ')
            alpha = mapreal8(slhaalpha,lslhaalpha,'alpha undefined. ')
            muSUSY = mapreal8(extpar(23),lextpar(23),'mu undefined. ')
            M3SQ = mapreal8(extpar(43),lextpar(43),'M_SQ undefined. ')
            M3SU = mapreal8(extpar(46),lextpar(46),'M_SU undefined. ')
            M3SD = mapreal8(extpar(49),lextpar(49),'M_SD undefined. ')
            cAt = mapreal8(extpar(11),lextpar(11),'At undefined. ')
            cAb = mapreal8(extpar(12),lextpar(12),'Ab undefined. ')
            if (pseudo.eq.0) then
               Mh = mapreal8(smassbo(25),lsmassbo(25)
     &              ,'light Higgs mass undefined. ')
            else if (pseudo.eq.1) then
               Mh = mapreal8(smassbo(36),lsmassbo(36)
     &              ,'pseudoscalar mass undefined. ')
            else if (pseudo.eq.2) then
               Mh = mapreal8(smassbo(35),lsmassbo(35)
     &              ,'heavy Higgs mass undefined. ')
            end if
         else
            MUE = 
     &dcmplx(mapreal8(extpar(23),lextpar(23),'mu undefined. '))
            M3SQ = mapreal8(extpar(43),lextpar(43),'M_SQ undefined. ')
            M3SU = mapreal8(extpar(46),lextpar(46),'M_SU undefined. ')
            M3SD = mapreal8(extpar(49),lextpar(49),'M_SD undefined. ')
            cAt = mapreal8(extpar(11),lextpar(11),'At undefined. ')
            cAb = mapreal8(extpar(12),lextpar(12),'Ab undefined. ')
            M_3=dcmplx(mapreal8(extpar(3),lextpar(3),'M_3 undefined. '))
            MA0 = mapreal8(extpar(26),lextpar(26),'MA0 undefined. ')

            M_1=dcmplx(mapreal8(feynhiggspar(1),lfeynhiggspar(1),
     &'M_1 undefined. '))
            M_2=dcmplx(mapreal8(feynhiggspar(2),lfeynhiggspar(2),
     &'M_2 undefined. '))

            !Setting of trilinear couplings in FeynHiggs
            if (lfeynhiggspar(3)) then
            cAu = mapreal8(feynhiggspar(3),lfeynhiggspar(3),
     &'A for FH undefined. ')
            cAmu = cAu
            cAtau = cAu
            cAc = cAu
            cAs = cAu
            cAe = cAu
            cAd = cAu
            else
            cAtau = mapreal8(feynhiggspar(13),lfeynhiggspar(13),
     &'A_TAU for FH undefined. ')
            cAc = mapreal8(feynhiggspar(14),lfeynhiggspar(14),
     &'A_C for FH undefined. ')
            cAs = mapreal8(feynhiggspar(15),lfeynhiggspar(15),
     &'A_S for FH undefined. ')
            cAmu = mapreal8(feynhiggspar(16),lfeynhiggspar(16),
     &'A_MU for FH undefined. ')
            cAu = mapreal8(feynhiggspar(17),lfeynhiggspar(17),
     &'A_U for FH undefined. ')
            cAd = mapreal8(feynhiggspar(18),lfeynhiggspar(18),
     &'A_D for FH undefined. ')
            cAe = mapreal8(feynhiggspar(19),lfeynhiggspar(19),
     &'A_E for FH undefined. ')
            end if

            !Setting of soft-breaking masses in FeynHiggs
            if (lfeynhiggspar(4)) then
            MSUSY = mapreal8(feynhiggspar(4),lfeynhiggspar(4),
     &'MSUSY for FH undefined. ')
            M3SL = MSUSY
            M3SE = MSUSY
            M2SL = MSUSY
            M2SE = MSUSY
            M2SQ = MSUSY
            M2SU = MSUSY
            M2SD = MSUSY
            M1SL = MSUSY
            M1SE = MSUSY
            M1SQ = MSUSY
            M1SU = MSUSY
            M1SD = MSUSY
            else
            M3SL = mapreal8(feynhiggspar(33),lfeynhiggspar(33),
     &'M3SL for FH undefined. ')
            M3SE = mapreal8(feynhiggspar(36),lfeynhiggspar(36),
     &'M3SE for FH undefined. ')
            M2SL = mapreal8(feynhiggspar(32),lfeynhiggspar(32),
     &'M2SL for FH undefined. ')
            M2SE = mapreal8(feynhiggspar(35),lfeynhiggspar(35),
     &'M2SE for FH undefined. ')
            M2SQ = mapreal8(feynhiggspar(42),lfeynhiggspar(42),
     &'M2SQ for FH undefined. ')
            M2SU = mapreal8(feynhiggspar(45),lfeynhiggspar(45),
     &'M2SU for FH undefined. ')
            M2SD = mapreal8(feynhiggspar(48),lfeynhiggspar(48),
     &'M2SD for FH undefined. ')
            M1SL = mapreal8(feynhiggspar(31),lfeynhiggspar(31),
     &'M1SL for FH undefined. ')
            M1SE = mapreal8(feynhiggspar(34),lfeynhiggspar(34),
     &'M1SE for FH undefined. ')
            M1SQ = mapreal8(feynhiggspar(41),lfeynhiggspar(41),
     &'M1SQ for FH undefined. ')
            M1SU = mapreal8(feynhiggspar(44),lfeynhiggspar(44),
     &'M1SU for FH undefined. ')
            M1SD = mapreal8(feynhiggspar(47),lfeynhiggspar(47),
     &'M1SD for FH undefined. ')
            end if

         end if

      !---SM
      else if ((model.eq.0).and.(.not.fhflag)) then
         
         Mh = mapreal8(smassbo(25),lsmassbo(25)
     &        ,'scalar Higgs mass undefined. ')

      end if

!---  2HDM
      if (model.eq.2) then
         if (.not.thdmcflag) then
            twohdmver = mapreal8(twohdmpar,ltwohdmpar,
     &           '2HDM version undefined. ')
            tanb = mapreal8(minpar(3),lminpar(3),'tanb undefined. ')
            alpha = mapreal8(slhaalpha,lslhaalpha,'alpha undefined. ')
            if (pseudo.eq.0) then
               Mh = mapreal8(smassbo(25),lsmassbo(25)
     &              ,'light Higgs mass undefined. ')
            else if (pseudo.eq.1) then
               Mh = mapreal8(smassbo(36),lsmassbo(36)
     &              ,'pseudoscalar mass undefined. ')
            else if (pseudo.eq.2) then
               Mh = mapreal8(smassbo(35),lsmassbo(35)
     &              ,'heavy Higgs mass undefined. ')
            end if
         endif
      end if
         
!     some settings for FeynHiggs if used
      if ((model.eq.1).or.((model.eq.0).and.fhflag)) then
         CKMlambda = -1
         CKMA      = -1
         CKMrhobar = -1
         CKMetabar = -1

         scalefactor = 1.d0

         Qtau = 0.d0
         Qt = 0.d0
         Qb = 0.d0

         MHp = 0.d0
      end if

      !Yukawa factors
      yukfac(1)=mapreal8(yukawafac(1),lyukawafac(1),
     &'charm yukawa-coupling undefined. ')
      yukfac(2)=mapreal8(yukawafac(2),lyukawafac(2),
     &'top yukawa-coupling undefined. ')
      yukfac(3)=mapreal8(yukawafac(3),lyukawafac(3),
     &'bottom yukawa-coupling undefined. ')

      if (model.eq.1) then
         yukfac(6)=mapreal8(yukawafac(4),lyukawafac(4),
     &'stop yukawa-coupling undefined. ')
         yukfac(7)=mapreal8(yukawafac(5),lyukawafac(5),
     &'sbottom yukawa-coupling undefined. ')
      else
         yukfac(6) = 0.d0
         yukfac(7) = 0.d0
      end if

      Mcharm = 1.d0
      Mbp = 1.d0
      Mtp = 1.d0

      if(yukfac(1).ne.0.d0)
     & Mcharm = mapreal8(sminputs(8),lsminputs(8),
     & 'charm mass undefined. ')

      !4.Generation parameters
!Form of the corresponding block in the input files:
!Block 4GEN
!  1   3.00000000e+02   # Mb'
!  2   3.00000000e+02   # Mt'
!  3   0.d0             # factor for yukawa-couplings: t'
!  4   0.d0             # b'
!  5   0.d0             # st'
!  6   0.d0             # sb'
      bltype = '4GEN'
      call readslha(12,bltype,blockflag)
      if (blockflag.eq.1) then
         do count1=1,20
            blocks(count1) = ' '
         enddo
         blocks(1) = '4GEN'
         call readblocks(12,blocks)
         yukfac(4) = mapreal8(fourgen(3),lfourgen(3),
     &'top` yukawa-coupling undefined. ')
         yukfac(5) = mapreal8(fourgen(4),lfourgen(4),
     &'bottom` yukawa-coupling undefined. ')
         if (model.eq.1) then
            yukfac(8) = mapreal8(fourgen(5),lfourgen(5),
     &'stop` yukawa-coupling undefined. ')
            yukfac(9) = mapreal8(fourgen(6),lfourgen(6),
     &'sbottom` yukawa-coupling undefined. ')
         else
            yukfac(8) = 0.d0
            yukfac(9) = 0.d0
         end if
         if(yukfac(5).ne.0.d0)
     & Mbp = mapreal8(fourgen(1),lfourgen(1),'b` mass undefined. ')
         if(yukfac(4).ne.0.d0)
     & Mtp = mapreal8(fourgen(2),lfourgen(2),'t` mass undefined. ')
      else
         yukfac(4) = 0.d0
         yukfac(5) = 0.d0
         yukfac(8) = 0.d0
         yukfac(9) = 0.d0
      end if

      !bottom sector
      if (lrenormbotpar(1)) then
         mbrunyuk = renormbotpar(1)
      else
         mbrunyuk = 0
      endif

      if (lrenormbotpar(2)) then
         tanbresum = renormbotpar(2)
      if (model.eq.0) then
         write(*,105)
         write(*,*)
     &"Tan(b)-Resummation for the SM is not reasonable!"
         write(*,105)
      else
      if (mbrunyuk.gt.0) then
         write(*,105)
         write(*,*)
     &"Running bottom mass in the MSSM is always resummed!"
         write(*,105)
      endif
      endif
      else
         tanbresum = 0
      endif

      if (lrenormbotpar(3)) then
         delmbfh = renormbotpar(3)
      else
         delmbfh = 0
      endif

      if (lrenormbotpar(4)) then
         mbossave = renormbotpar(4)
      else
         mbossave = 0.D0
      endif

      if (lrenormbotpar(5)) then
         mbrunloop = renormbotpar(5)
      else
         mbrunloop = 0
      endif

      !sbottom sector
      if (model.eq.1) then
      !first check whether all flags are set
         if (.not.lrenormsbotpar(1)) then
            write(*,105)
            write(*,*)
     &"Please choose a scheme for mb in the sbottom sector!"
            write(*,105)
            stop
         end if
         if (.not.lrenormsbotpar(2)) then
            write(*,105)
            write(*,*)
     &"Please choose a scheme for Ab in the sbottom sector!"
            write(*,105)
            stop
         end if
         if (.not.lrenormsbotpar(3)) then
            write(*,105)
            write(*,*)
     &"Please choose a scheme for thetab in the sbottom sector!"
            write(*,105)
            stop
         end if

         rensbotc = 0
         do count1=1,3
            if (renormsbotpar(count1).eq.2) rensbotc = rensbotc + 1
         enddo
         if (rensbotc.ne.1) then
            write(*,105)
            write(*,*)
     &"Exactly one sbottom parameter has to be choosen -dependent-!"
            write(*,105)
            stop
         endif
         mbsbch = renormsbotpar(1)
         Abch = renormsbotpar(2)
         thetabch = renormsbotpar(3)
      endif

      !setting 2HDM back to MSSM
      if (model.eq.2) then
         tanbresum = 0
         mbsbch = 2
         Abch = 0
         thetabch = 0
      end if

      if(extflag) then
         norderggh = 1
         norderbbh = -1
         close(12)
      else
         norderggh = sushipar(5)
         norderbbh = sushipar(6)

         blocks(1) = 'DISTRIB'
         blocks(2) = 'SCALES'
         blocks(3) = 'VEGAS'
         blocks(4) = 'PDFSPEC'
         call readblocks(12,blocks)

         SUpdfs(1) = pdfnamelo
         SUpdfs(2) = pdfnamenlo
         SUpdfs(3) = pdfnamennlo
         SUiset = pdfspecpar(4)

         if(sushipar(3).eq.0) then
            ppcoll = .true.
         else
            ppcoll = .false.            
         endif
         cme = 
     &        mapreal8(sushipar(4),lsushipar(4),'cm-energy undefined. ')

         !scale choices
         muRfactor = 
     &     mapreal8(scalespar(1),lscalespar(1),'muR undefined. ')
         muFfactor = 
     &     mapreal8(scalespar(2),lscalespar(2),'muF undefined. ')
         !scalespt determines whether muR = factor * Sqrt(mh^2+p_T^2)
         !should be used in case of p_T distributions.
         if (lscalespar(3)) then
            if (scalespar(3).eq.1) scalespt = .true.
         else
            scalespt = .false.
         endif

         if (lscalespar(4)) then
            muBfactor = scalespar(4)
         else
            muBfactor = 1.d0
         endif

         !distribution parameters
         dist = 0
         ptc = 0
         rapc = 0
         if (ldistribpar(1)) dist = distribpar(1)
         if (ldistribpar(2)) ptc = distribpar(2)
         if (ldistribpar(3)) rapc = distribpar(3)

         minptc = 0.d0
         minrapc = 0.d0
         if (ldistribpar(21)) minptc = distribpar(21)
         if (ldistribpar(22)) maxptc = distribpar(22)
         if (ldistribpar(31)) minrapc = distribpar(31)
         if (ldistribpar(32)) maxrapc = distribpar(32)

         if ((ptc.ge.2).and.(ldistribpar(22).eqv.(.false.))) then
            write(*,*) "Please specify the max. value of p_t."
            stop
         end if
         if (((rapc.eq.1).or.(rapc.eq.3)).and.
     &        (ldistribpar(32).eqv.(.false.))) then
            write(*,*) "Please specify the max. value of y/eta."
            stop
         end if

         if ((dist.eq.1).or.(dist.eq.3)) then
            if (ldistribpar(22).eqv.(.false.)) then
       write(*,*) "Please specify the value of p_t for the diff. XS."
               stop
            end if
         end if
         if ((dist.eq.2).or.(dist.eq.3)) then
            if (ldistribpar(32).eqv.(.false.)) then
       write(*,*) "Please specify the value of y/eta for the diff. XS."
               stop
            end if
         end if

         pseudorap = .false.
         if(distribpar(4).eq.0) then
            pseudorap = .false.
         else
            pseudorap = .true.
         endif
         if(dist.eq.0) then
            pty = .false.
         else
            pty = .true.
         endif

         !VEGAS parameters
         ncall = 10000
         itmx = 5
         nprn = 10

         if(vegaspar(1).ne.0) then
            ncall = vegaspar(1)
            itmx = vegaspar(2)
            nprn = vegaspar(3)
         else
            write(*,105)
         write(*,*) 'Number of points for vegas integration undefined.'
         write(*,*) 'Hence, the standard values will be used:'
         write(*,*) 'Number of points = 10000'
         write(*,*) 'Number of iterations = 5'
         write(*,*) 'Print = 10 (table)'
            write(*,105)
         endif
      endif

 105  format('#--------------------------------------------------#')
      end

C-}}}
C-{{{ subroutine outputsushi

      subroutine outputsushi(fhflag,thdmcflag,delmb)

      implicit none

      logical fhflag,thdmcflag
      double precision xl(10),xu(10),acc
      integer ndm,ncall,itmx,nprn
      logical ppcoll
      double precision delmb, gghnnloout, gghnnloout2
      double precision effres, res, effres2, alphasPDFm
      character resstring*30, effresstring*30
      character effresstring2*30
      integer date_time(8)
      character realcl(3)*12

      include 'commons/common-inputoutput.f'
      !internal definitions

!defined at other places:
!AlfasMZ,muRfactor,muFfactor,cme,dist,prefix,prefix2,pty,iset
!norderggh,mw,mc,ew,mz,mbmb,renscheme,mt,pseudo,tanbresum,pseudorap
      include 'commons/common-slha.f'
      include 'commons/common-consts.f'
      include 'commons/common-vars.f'
      include 'commons/common-ren.f'
      include 'commons/common-quark.f'
      include 'commons/common-int.f'
      include 'commons/common-citations.f'

      common /coll/ ppcoll
      common /bveg1/ xl,xu,acc,ndm,ncall,itmx,nprn

      open(unit=13,file=jfnameact,status='unknown')

      call printcopysushi(0,13)

      call date_and_time(realcl(1),realcl(2),realcl(3),date_time)

      write (13,106) date_time(3), date_time(2), date_time(1),
     &date_time(5), date_time(6), date_time(7)

      write(13,103)
     &"# For the reconstructed input file, check below.   #"
      write(13,103)
     &"#--------------------------------------------------#"
      if ((ew.eq.1).and.(norderggh.ge.1)) then
         citations(11) = 1
         citations(12) = 1
      endif
      if ((ew.eq.2).and.(norderggh.ge.1).and.
     &((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0))) then
         citations(10) = 1
      endif
      write(13,"(a)")
     &"# Please cite the following papers (for this run):"
      call printcite(13,1,'# ')
      write(13,103)
     &"#--------------------------------------------------#"

      !most important results
      if ((dist.eq.0).or.(dist.eq.2)) then
        effresstring = "ggh XS in pb"
      else
        effresstring = "ggh XS in pb/GeV"
      endif
      if (model.eq.0) then
        effres = sm
      else if ((model.eq.1).or.(model.eq.2)) then
        effres = mssm
      endif
      if ((dist.eq.0).or.(dist.eq.2)) then
        resstring = "ggh XS in pb"
      else
        resstring = "ggh XS in pb/GeV"
      endif
      if ((model.eq.1).or.(model.eq.2)) then
            res = CSsusy(1)
         if (norderggh.ge.1) then
            res = CSsusy(2)
         endif
      else if (model.eq.0) then
            res = CSsm(1)
         if(norderggh.ge.1) then
            citations(26) = 1
            citations(20) = 2
            citations(21) = 2
            citations(22) = 2
            res = CSsm(2)
         endif
      endif
      if (norderggh.ge.0) then
            write(13,103) 
     &"Block SUSHIggh # Bon appetit"
         if (((ew.ge.1).or.(norderggh.ge.2)).and.(norderggh.ge.1)) then
            write(13,102) 1,effres,effresstring
         else
            write(13,102) 1,res,resstring
         endif
      endif

      if (((dist.eq.1).or.(dist.eq.3).or.(ptcut))) then
            write(13,103) 
     &"# Note: Fixed order p_T distribution (no resummation)!"
            write(13,103) "# p_T < 20 GeV not reasonable!"
      endif

      if (model.eq.0) then
        if (norderbbh.eq.0) then
        effres2 = SUbbh(1)
        else if (norderbbh.ge.0) then
        effres2 = SUbbh(2)
        end if
        if (norderbbh.eq.2) then
        if (.not.((ptc.gt.0).or.(rapc.gt.0))) then
        effres2 = SUbbh(3)
        end if
        end if
        effresstring2 = "bbh XS in pb"
      endif
      if ((model.eq.1).or.(model.eq.2)) then
        if (norderbbh.eq.0) then
        effres2 = SUbbhsusy(1)
        else if (norderbbh.ge.1) then
        effres2 = SUbbhsusy(2)
        end if
        if (norderbbh.eq.2) then
        if ((ptc.eq.0).and.(rapc.eq.0)) then
        effres2 = SUbbhsusy(3)
        end if
        end if
        effresstring2 = "bbh XS in pb"
      endif
      if ((norderbbh.ge.0).and.(dist.eq.0)) then
            write(13,103) 
     &"Block SUSHIbbh # Bon appetit"
            write(13,102) 1,effres2,effresstring2
      endif

      if (((dist.eq.1).or.(dist.eq.3).or.(ptcut))) then
            write(13,103) 
     &"# Note: Fixed order p_T distribution (no resummation)!"
            write(13,103) "# p_T < 20 GeV not reasonable!"
      endif

      gghnnloout = SUggh(2)
      gghnnloout2 = SUggh(3)
      if ((norderggh.ne.3).or.(pseudo.ne.0)) then
      if (model.eq.0) gt3 = 1
      gghnnloout = SUggh(2) * gt3**2
      gghnnloout2 = SUggh(3) * gt3**2
      end if

      !detailled output
      !SM ggh
      if (((model.eq.0)).and.(norderggh.ge.0)) then
         if ((dist.eq.0).or.(dist.eq.2)) then
          write(13,103) 
     &"Block XSGGH # ggh SM-Cross sec. in pb (w/o EW)"
         else
          write(13,103)
     &"Block XSGGH # ggh SM-Cross sec. in pb/GeV  (w/o EW)"
         endif
         if (norderggh.eq.0) then
         write(13,102) 1,CSsm(1),"LO"
         !write(13,102) 2,smerr(1),"LO error"
         end if
         if(norderggh.ge.1) then
            write(13,102) 2,CSsm(2),"NLO"
            !write(13,102) 4,smerr(2),"NLO error"
            write(13,102) 21,ggsm,"NLO gg"
            !write(13,102) 41,ggsmerr,"NLO gg error"
            write(13,102) 22,qgsm,"NLO qg"
            !write(13,102) 42,qgsmerr,"NLO qg error"
            write(13,102) 23,qqsm,"NLO qq"
            !write(13,102) 43,qqsmerr,"NLO qq error"
         endif
         if ((((ew.ge.1).or.(norderggh.ge.2)).and.(norderggh.ge.1))
     &.and.(((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0)).or.(ew.eq.1)))
     & then
            write(13,103) "Block XSGGHEFF # ggh SM-Cross sec."
            if (((ew.eq.2).or.(norderggh.ge.2))
     &.and.((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0))) then
               write(13,102) 1,gghnnloout,"ggh@NLO"
               !write(13,102) 2,SUggherr(2),"ggh@NLO error"
               if(norderggh.ge.2) then
                  write(13,102) 2,gghnnloout2,"ggh@NNLO"
                  !write(13,102) 4,SUggherr(3),"ggh@NNLO error"
               endif
            endif
               if (ew.eq.1) then
                  citations(11) = 1
                  citations(12) = 1
                  write(13,102) 3,elw,"electroweak factor"
               endif
               if (ew.eq.2) then
                  citations(10) = 1
                  write(13,102) 3,elw-1,"SM electroweak factor"
               endif
               !write(13,102) 4,sm,"weighted result"
               !write(13,102) 5,errsm,"weighted error"
         endif
      endif
      !MSSM ggh
      if (((model.eq.1).or.(model.eq.2)).and.(norderggh.ge.0)) then
         if ((dist.eq.0).or.(dist.eq.2)) then
            write(13,103)
     &"Block XSGGH # ggh MSSM-Cross sec. in pb (w/o EW)"
         else
            write(13,103)
     &"Block XSGGH # ggh MSSM-Cross sec. in pb/GeV  (w/o EW)"
         endif
         if (norderggh.eq.0) then
         write(13,102) 1,CSsusy(1),"LO"
         !write(13,102) 2,susyerr(1),"LO error"
         end if
         if (norderggh.ge.1) then
            write(13,102) 2,CSsusy(2),"NLO"
            !write(13,102) 4,susyerr(2),"NLO error"
            write(13,102) 21,ggsusy,"NLO gg"
            !write(13,102) 41,ggsusyerr,"NLO gg error"
            write(13,102) 22,qgsusy,"NLO qg"
            !write(13,102) 42,qgsusyerr,"NLO qg error"
            write(13,102) 23,qqsusy,"NLO qq"
            !write(13,102) 43,qqsusyerr,"NLO qq error"
         endif
         if ((((ew.ge.1).or.(norderggh.ge.2)).and.(norderggh.ge.1))
     &.and.(((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0)).or.(ew.eq.1)))
     & then
            write(13,103) "Block XSGGHEFF # ggh MSSM-Cross sec."
            if (((ew.eq.2).or.(norderggh.ge.2))
     &.and.((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0))) then
               write(13,102) 1,gghnnloout,"ggh@NLO MSSM"
               !write(13,102) 2,SUggherr(2),"ggh@NLO SM error"
               if(norderggh.ge.2) then
                  write(13,102) 2,gghnnloout2,"ggh@NNLO MSSM"
                  !write(13,102) 4,SUggherr(3),"ggh@NNLO SM error"
               endif
            endif
               if (ew.eq.1) then
                  citations(11) = 1
                  citations(12) = 1
                  write(13,102) 3,elw,"electroweak factor"
               endif
               if (ew.eq.2) then
                  citations(10) = 1
                  write(13,102) 3,elw-1,"SM electroweak factor"
               endif
               !write(13,102) 4,mssm,"weighted result"
               !write(13,102) 7,errmssm,"weighted error"
         endif
      endif
      !SM MSSM bbh
      if (((model.eq.0)).and.(norderbbh.ge.0)) then
         if (dist.eq.0) then
            write(13,103) "Block XSBBH # bbh SM-Cross sec. in pb"
            write(13,102) 1,SUbbh(1),"LO"
            !if ((ptc.gt.0).or.(rapc.gt.0)) then
            !write(13,102) 2,SUbbherr(1),"LO error"
            !end if
            if (norderbbh.gt.0) then
               write(13,102) 2,SUbbh(2),"NLO"
            !if ((ptc.gt.0).or.(rapc.gt.0)) then
            !write(13,102) 4,SUbbherr(2),"NLO error"
            !end if
            end if
            if (norderbbh.gt.1) then
            if ((ptc.eq.0).and.(rapc.eq.0)) then
               write(13,102) 3,SUbbh(3),"NNLO"
            end if
            end if
         endif
      endif
      if (((model.eq.1).or.(model.eq.2)).and.(norderbbh.ge.0)) then
         if (dist.eq.0) then
            write(13,103)
     &"Block XSBBH # bbh MSSM-Cross sec. in pb"
            write(13,102) 1,SUbbhsusy(1),"LO"
            !if ((ptc.gt.0).or.(rapc.gt.0)) then
            !write(13,102) 2,SUbbhsusyerr(1),"LO error"
            !end if
            if (norderbbh.gt.0) then
               write(13,102) 2,SUbbhsusy(2),"NLO"
            !if ((ptc.gt.0).or.(rapc.gt.0)) then
            !write(13,102) 4,SUbbhsusyerr(2),"NLO error"
            !end if
            end if
            if (norderbbh.gt.1) then
            if ((ptc.eq.0).and.(rapc.eq.0)) then
               write(13,102) 3,SUbbhsusy(3),"NNLO"
            end if
            end if
         endif
      endif
      !effective couplings in MSSM
      if (model.ge.1) then
         if (pseudo.eq.0) then
            write(13,103) 
     &"Block HGGSUSY # couplings of light Higgs h to 3. generation"
         else if (pseudo.eq.1) then
            write(13,103) 
     &"Block HGGSUSY # couplings of pseudoscalar A to 3. generation"
         else if (pseudo.eq.2) then
            write(13,103) 
     &"Block HGGSUSY # couplings of heavy Higgs H to 3. generation"
         end if
         !write(13,102) 101,c1sm13,  'c1SM 1-loop'
         !write(13,102) 102,c1sm23,  'c1SM 2-loop'
         !write(13,102) 103,c1sm33,  'c1SM 3-loop'
         !write(13,102) 201,c1susy1t3,'c1SUSYt 1-loop'
         !write(13,102) 202,c1susy2t3,'c1SUSYt 2-loop'
         !write(13,102) 301,c1susy1b3,'c1SUSYb 1-loop'
         !write(13,102) 302,c1susy2b3,'c1SUSYb 2-loop'
         write(13,102) 101,gt3,'g_t^phi'
         if (model.eq.1) then
         write(13,102) 111,gt13,'g_st11^phi'
         write(13,102) 122,gt23,'g_st22^phi'
         write(13,102) 112,gth123,'g_st12^phi'
         write(13,102) 121,gth213,'g_st21^phi'
         end if
         write(13,102) 201,gb3,'g_b^phi'
         if (model.eq.1) then
         write(13,102) 211,gb13,'g_sb11^phi'
         write(13,102) 222,gb23,'g_sb22^phi'
         write(13,102) 212,gbh123,'g_sb12^phi'
         write(13,102) 221,gbh213,'g_sb21^phi'
         end if
         if((yukfac(4).ne.0.d0).or.(yukfac(5).ne.0.d0)) then
            if (pseudo.eq.0) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of light Higgs h to 4. generation"
            else if (pseudo.eq.1) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of pseudoscalar A to 4. generation"
            else if (pseudo.eq.2) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of heavy Higgs H to 4. generation"
            end if
            !write(13,102) 101,c1sm14,  'c1SM 1-loop'
            !write(13,102) 102,c1sm24,  'c1SM 2-loop'
            !write(13,102) 103,c1sm34,  'c1SM 3-loop'
            !write(13,102) 201,c1susy1t4,'c1SUSYt 1-loop'
            !write(13,102) 202,c1susy2t4,'c1SUSYt 2-loop'
            !write(13,102) 301,c1susy1b4,'c1SUSYb 1-loop'
            !write(13,102) 302,c1susy2b4,'c1SUSYb 2-loop'
            write(13,102) 101,gt4,'g_t^phi'
            if (model.eq.1) then
            write(13,102) 111,gt14,'g_st11^phi'
            write(13,102) 122,gt24,'g_st22^phi'
            write(13,102) 112,gth124,'g_st12^phi'
            write(13,102) 121,gth214,'g_st21^phi'
            end if
            write(13,102) 201,gb4,'g_b^phi'
            if (model.eq.1) then
            write(13,102) 211,gb14,'g_sb11^phi'
            write(13,102) 222,gb24,'g_sb22^phi'
            write(13,102) 212,gbh124,'g_sb12^phi'
            write(13,102) 221,gbh214,'g_sb21^phi'
            end if
         endif
      endif
      !additional output
      if (model.ge.1) then
         write(13,103) 'Block MASSOUT'
         if(gc.ne.0.d0) write(13,102) 4,mcmc,'m_c(m_c), MSbar'
         write(13,102) 5,mbmb,'m_b(m_b), MSbar'
         write(13,102) 6,mt,'m_t(pole)'
         write(13,102) 23,mZ,'m_Z'
         write(13,102) 24,mW,'m_W'
         if (pseudo.eq.0) then
            write(13,102) 25,Mh,'Mh in GeV'
         else if (pseudo.eq.1) then
            write(13,102) 36,Mh,'MA in GeV'
         else if (pseudo.eq.2) then
            write(13,102) 35,Mh,'MH in GeV'
         end if
         if (model.eq.1) then
         write(13,102) 1000005,Msbot1,'sbottom1 mass in GeV'
         write(13,102) 2000005,Msbot2,'sbottom2 mass in GeV'
         write(13,102) 1000006,Mstop1,'stop1 mass in GeV'
         write(13,102) 2000006,Mstop2,'stop2 mass in GeV'
         end if
         if ((model.eq.2).and.(thdmcflag)) then
         write(13,103) 'Block 2HDMCOUT # 2HDMC results for'
          write(13,1020) 1,int(thdmcres(7)),'stability, 0=failed, 1=ok'
          write(13,1020) 2,int(thdmcres(8)),
     &    'perturbativity, 0=failed, 1=ok'
          write(13,1020) 3,int(thdmcres(9)),'unitarity, 0=failed, 1=ok'
          write(13,102) 4,thdmcres(4),'alpha (Higgs mixing angle)'
          write(13,102) 5,thdmcres(5),'tan(beta)'
          write(13,102) 25,thdmcres(1),'Mh in GeV'
          write(13,102) 35,thdmcres(3),'MA in GeV'
          write(13,102) 36,thdmcres(2),'MH in GeV'
         end if
         if ((model.eq.1).and.(fhflag)) then
         write(13,103) 'Block ALPHA # Higgs mixing parameter from FH'
         write(13,107) alpha,'alpha'
         end if
         if (model.eq.1) then
         write(13,103) 'Block STOPMIX # stop mixing matrix'
         write(13,108) 1,1,cthetat,'V_11'
         write(13,108) 1,2,sthetat,'V_12'
         write(13,108) 2,1,-sthetat,'V_21'
         write(13,108) 2,2,cthetat,'V_22'
         write(13,103) 'Block SBOTMIX # sbottom mixing matrix'
         write(13,108) 1,1,cthetab,'V_11'
         write(13,108) 1,2,sthetab,'V_12'
         write(13,108) 2,1,-sthetab,'V_21'
         write(13,108) 2,2,cthetab,'V_22'
         write(13,103) 'Block AD'
         write(13,108) 3,3,Ab,'used Ab in GeV - def. accord. to scheme'
         write(13,103) 'Block AU'
         write(13,108) 3,3,At,'used At in GeV'
         end if
         if (model.eq.1) then
         if((gc.ne.0.d0).or.(gb.ne.0.d0)) then
            write(13,103) 'Block INTERNALMASSES # Masses in GeV'
            if(gc.ne.0.d0) write(13,102) 40,mcos,'m_c(pole)'
            if(gb.ne.0.d0) then
               write(13,102) 50,mbmb       ,'m_b(m_b), MSbar'
               write(13,102) 51,mbMSbarmuR ,'m_b(mu_R) MSbar'
               write(13,102) 52,mbOS       ,'m_b(pole)'
            if (norderggh.ge.0) then
               write(13,102) 53,mb    ,'m_b used for internal masses'
               if (tanbresum.eq.1) then
               write(13,102) 54,mbyuk/(1+delmb),'m_b for bottom Yukawa'
               else if (tanbresum.eq.2) then
               if (pseudo.eq.1) then
               write(13,102) 54,mbyuk* (1.d0 - (1.d0/tanb**2)*delmb)
     &              * (1.d0/(1.d0+delmb)),'m_b for bottom Yukawa'
               else if (pseudo.eq.0) then
               write(13,102) 54,mbyuk* (1.d0 - (1.d0/(tanb*Tan(alpha)))
     &          *delmb)* (1.d0/(1.d0+delmb)),'m_b for bottom Yukawa'
               else if (pseudo.eq.2) then
               write(13,102) 54,mbyuk* (1.d0 + (Tan(alpha)/tanb)*delmb)
     &              * (1.d0/(1.d0+delmb)),'m_b for bottom Yukawa'
                end if 
               else
               write(13,102) 54,mbyuk    ,'m_b for bottom Yukawa'
               endif
            endif
               write(13,102) 55,mbsb     ,'m_b for sbottom sector'
            endif
         endif
         endif
      else if (model.eq.0) then
         write(13,103) 'Block MASSOUT'
         write(13,102) 25,Mh,'SM-Mh in GeV'
         if((gc.ne.0.d0).or.(gb.ne.0.d0)) then
            write(13,103) 'Block INTERNALMASSES'
            if(gc.ne.0.d0) write(13,102) 40,mcos,'mcpole in GeV'
            if(gb.ne.0.d0) then
               write(13,102) 50,mbmb       ,'m_b(m_b), MSbar'
               write(13,102) 51,mbMSbarmuR ,'m_b(mu_R) MSbar'
               write(13,102) 52,mbOS       ,'m_b(pole)'
               write(13,102) 53,mb    ,'m_b used for internal masses'
               write(13,102) 54,mbyuk ,'m_b used for bottom Yukawa'
            endif
         endif
      end if
      write(13,103) 'Block ALPHASOUT # values from LHAPDF set'
      if (scalespt) then
      if (norderggh.ge.1) then
       call SUinitpdf(2,SUpdfs(2),SUiset)
       write(13,102) 2,alphasPDFm(2,muRfactor*dsqrt(mh**2+maxptc**2)),
     &'alpha_s(muR)@NLO'
       write(13,102) 20,alphasPDFm(2,muRfactor*mh),
     &'alpha_s(muR(w/o)pt)@NLO'
      end if
      else
      if ((norderggh.eq.0).or.(norderbbh.eq.0)) then
       call SUinitpdf(1,SUpdfs(1),SUiset)
       write(13,102) 1,alphasPDFm(1,muR),'alpha_s(muR)@LO'
      end if
      if ((norderggh.ge.1).or.(norderbbh.ge.1)) then
       call SUinitpdf(2,SUpdfs(2),SUiset)
       write(13,102) 2,alphasPDFm(2,muR),'alpha_s(muR)@NLO'
      end if

      if (.not.((dist.ge.1).or.(ptcut).or.(rapcut))) then
      if ((norderggh.ge.2).or.(norderbbh.ge.2)) then
       call SUinitpdf(3,SUpdfs(3),SUiset)
       write(13,102) 3,alphasPDFm(3,muR),'alpha_s(muR)@NNLO'
      end if
      end if

      end if

      write(13,103)
     &"#--------------------------------------------------#"
      write(13,103)
     &"# Reconstructed input file of this run             #"
      write(13,103)
     &"#--------------------------------------------------#"

      !Reproduction of the input file
      write(13,103) 'Block SUSHI'
       write(13,1020) 1,model,'Chosen model: 0=SM, 1=MSSM, 2=2HDM'
       write(13,1020) 2,pseudo,'Chosen Higgs particle: 0=h, 1=A, 2=H'
       if (ppcoll) then
       write(13,1020) 3,0,'Particle collider: 0=pp, 1=ppbar'
       else
       write(13,1020) 3,1,'Particle collider: 0=pp, 1=ppbar'
       end if
       write(13,102)  4,cme,'center-of-mass energy in GeV'
       write(13,1020) 5,norderggh,'Order for ggh'
       write(13,1020) 6,norderbbh,'Order for bbh'
       write(13,1020) 7,ew,'Electroweak contributions to ggh'
      if ((model.eq.2).and.(thdmcflag.eqv.(.false.))) then
       write(13,103) 'Block 2HDM'
       write(13,1070) twohdmver,'2HDM type'
      end if
      if (thdmcflag) then
         write(13,103) 'Block 2HDMC'
         write(13,1020) 1,thdmckey,'parametrization of 2HDM'
         write(13,1020) 2,twohdmver,'2HDM type'
         if (thdmckey.eq.1) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 4,m12,'m12'
            write(13,102) 11,tparam(1),'lambda1'
            write(13,102) 12,tparam(2),'lambda2'
            write(13,102) 13,tparam(3),'lambda3'
            write(13,102) 14,tparam(4),'lambda4'
            write(13,102) 15,tparam(5),'lambda5'
            write(13,102) 16,tparam(6),'lambda6'
            write(13,102) 17,tparam(7),'lambda7'
         else if (thdmckey.eq.2) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 4,m12,'m12'
            write(13,102) 21,tparam(1),'mh'
            write(13,102) 22,tparam(2),'mH'
            write(13,102) 23,tparam(3),'mA'
            write(13,102) 24,tparam(4),'mC'
            write(13,102) 25,tparam(5),'sin(beta-alpha)'
            write(13,102) 26,tparam(6),'lambda6'
            write(13,102) 27,tparam(7),'lambda7'
         else if (thdmckey.eq.3) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 31,tparam(1),'mh'
            write(13,102) 32,tparam(2),'mH'
            write(13,102) 33,tparam(3),'sin(beta-alpha)'
            write(13,102) 34,tparam(5),'Z4'
            write(13,102) 35,tparam(6),'Z5'
            write(13,102) 36,tparam(7),'Z7'
         else
            call printdie('thdmckey not implemented')
         endif
      endif
      write(13,103) 'Block SMINPUTS'
       write(13,102) 1,invAlfa,'1/alpha_em(MZ) SM MSbar'
       write(13,102) 2,GF,'G_F'
       write(13,102) 3,AlfasMZ,'alpha_s(m_Z)'
       write(13,102) 4,mZ,'m_Z(pole)'
       write(13,102) 5,mbmb,'m_b(m_b)'
       write(13,102) 6,mt,'m_t(pole)'
       if (yukfac(1).ne.(0.d0)) write(13,102) 8,mcmc,'m_c(m_c)'
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &(model.eq.1)) then
      write(13,103) 'Block MINPAR'
       write(13,102) 3,tanb,'tan(beta)'
      end if
      !Specific SUSY parameters
      if (model.eq.1) then
      write(13,103) 'Block EXTPAR'
       write(13,102) 3,mgl,'Gluino mass'
       write(13,102) 11,Real(cAt),'A_t'
       write(13,102) 12,Real(cAb),'A_b'
       write(13,102) 23,muSUSY,'mu'
       if (fhflag) write(13,102) 26,mA0,'mA'
       write(13,102) 43,M3SQ,'M3SQ'
       write(13,102) 46,M3SU,'M3SU'
       write(13,102) 49,M3SD,'M3SD'
      if (fhflag) then
      write(13,103) 'Block FEYNHIGGS'
       write(13,102) 1,Real(M_1),'M1'
       write(13,102) 2,Real(M_2),'M2'
       write(13,102) 13,Real(cAtau),'A_tau'
       write(13,102) 14,Real(cAc),'A_c'
       write(13,102) 15,Real(cAs),'A_s'
       write(13,102) 16,Real(cAmu),'A_mu'
       write(13,102) 17,Real(cAu),'A_u'
       write(13,102) 18,Real(cAd),'A_d'
       write(13,102) 19,Real(cAe),'A_e'
       write(13,102) 31,M1SL,'M1SL'
       write(13,102) 32,M2SL,'M2SL'
       write(13,102) 33,M3SL,'M3SL'
       write(13,102) 34,M1SE,'M1SE'
       write(13,102) 35,M2SE,'M2SE'
       write(13,102) 36,M3SE,'M3SE'
       write(13,102) 41,M1SQ,'M1SQ'
       write(13,102) 42,M2SQ,'M2SQ'
       write(13,102) 44,M1SU,'M1SU'
       write(13,102) 45,M2SU,'M2SU'
       write(13,102) 47,M1SD,'M1SD'
       write(13,102) 48,M2SD,'M2SD'
      end if
      end if
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &((model.eq.1).and.(fhflag.eqv.(.false.)))) then
       write(13,103) 'Block ALPHA # Higgs mixing parameter'
       write(13,107) alpha,'alpha'
      end if
      if (model.eq.0) then
      write(13,103) 'Block MASS'
       write(13,102) 25,Mh,'Higgs mass'
      end if
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &((model.eq.1).and.(fhflag.eqv.(.false.)))) then
      write(13,103) 'Block MASS'
        if (pseudo.eq.0) write(13,102) 25,Mh,'Light Higgs mass'
        if (pseudo.eq.1) write(13,102) 36,Mh,'Pseudoscalar Higgs mass'
        if (pseudo.eq.2) write(13,102) 35,Mh,'Heavy Higgs mass'
      end if
      !only write relevant DISTRIBUTION input
      write(13,103) 'Block DISTRIB'
       if (dist.eq.0) then
        resstring = 'total XS'
       else if (dist.eq.1) then
        resstring = 'diff. XS dsigma/dpt'
       else if (dist.eq.2) then
        resstring = 'diff. XS dsigma/dy'
        if (pseudorap) resstring = 'diff. XS dsigma/deta'
       else if (dist.eq.3) then
        resstring = 'diff. XS dsigma/dy/dpt'
        if (pseudorap) resstring = 'diff. XS dsigma/deta/dpt'
       end if
      write(13,1020) 1,dist,resstring
      if (ptc.eq.0) then
       if ((dist.eq.1).or.(dist.eq.3))
     & write(13,102) 22,maxptc,'pt in GeV (for diff. XS evaluation)'
      else if (ptc.ge.1) then
       write(13,1020) 2,ptc,'pt cut'
       if (ptc.eq.1) then
       write(13,102) 21,minpt,'Minimal pt value in GeV'
       else if (ptc.eq.2) then
       write(13,102) 22,maxpt,'Maximal pt value in GeV'
       else if (ptc.eq.3) then
       write(13,102) 21,minpt,'Minimal pt value in GeV'
       write(13,102) 22,maxpt,'Maximal pt value in GeV'
       end if
      end if
      if (pseudorap) then
       if (rapc.eq.0) then
        if ((dist.eq.2).or.(dist.eq.3))
     &    write(13,102) 32,maxrapc,'eta (for diff. XS evaluation)'
       else if (rapc.ge.1) then
          write(13,1020) 3,rapc,'eta cut'
          if (rapc.eq.2) then
          write(13,102) 31,minrap,'Minimal eta value'
          else if (rapc.eq.1) then
          write(13,102) 32,maxrap,'Maximal eta value'
          else if (rapc.eq.3) then
          write(13,102) 31,minrap,'Minimal eta value'
          write(13,102) 32,maxrap,'Maximal eta value'
          end if
       end if
      else
       if (rapc.eq.0) then
        if ((dist.eq.2).or.(dist.eq.3))
     &    write(13,102) 32,maxrapc,'y (for diff. XS evaluation)'
       else if (rapc.ge.1) then
          write(13,1020) 3,rapc,'y cut'
          if (rapc.eq.2) then
          write(13,102) 31,minrap,'Minimal y value'
          else if (rapc.eq.1) then
          write(13,102) 32,maxrap,'Maximal y value'
          else if (rapc.eq.3) then
          write(13,102) 31,minrap,'Minimal y value'
          write(13,102) 32,maxrap,'Maximal y value'
          end if
       end if
      end if

      if (pseudorap) write(13,1020) 4,1,'Pseudorapidity'

      write(13,103) 'Block SCALES'
       if (scalespt) then
       write(13,102) 1,muRfactor,
     &'Renormalization scale muR/Sqrt(mh^2+pt^2)'
       write(13,102) 2,muFfactor,
     &'Factorization scale muF/Sqrt(mh^2+pt^2)'
       write(13,1020) 3,1,'Use p_t dependent scale choice'
       else
       write(13,102) 1,muR/mh,'Renormalization scale muR/mh'
       write(13,102) 2,muF/mh,'Factorization scale muF/mh'
       end if
      write(13,103) 'Block RENORMBOT'
       write(13,1020) 1,mbrunyuk,'mb used for bottom Yukawa'
      if (model.eq.1) then
       write(13,1020) 2,tanbresum,'Resummation of sbottom effects'
       write(13,1020) 3,delmbfh,'Delta_b from FeynHiggs'
      end if
      if (mbossave.gt.0.D0)
     &write(13,102) 4,mbossave,'Fixed m_b(pole) in GeV'
      if (model.eq.1) then
      write(13,103) 'Block RENORMSBOT'
       write(13,1020) 1,mbsbch,'Renormalization of m_b'
       write(13,1020) 2,Abch,'Renormalization of A_b'
       write(13,1020) 3,thetabch,'Renormalization of theta_b'
      end if
      write(13,103) 'Block PDFSPEC'
       write(13,1022) 1,SUpdfs(1),'LO   PDF set'
       write(13,1022) 2,SUpdfs(2),'NLO  PDF set'
       write(13,1022) 3,SUpdfs(3),'NNLO PDF set'
       write(13,1020) 4,SUiset,'PDF set number'
      write(13,103) 'Block VEGAS'
       write(13,1021) 1,ncall,'Number of points'
       write(13,1021) 2,itmx,'Number of iterations'
       write(13,1021) 3,nprn,'Output format of VEGAS integration'
      write(13,103) 'Block FACTORS'
       write(13,102) 1,yukfac(1),
     &'Factor multiplied with Yukawa of c quark'
       write(13,102) 2,yukfac(2),'t quark'
       write(13,102) 3,yukfac(3),'b quark'
       if (model.eq.1) then
       write(13,102) 4,yukfac(6),'top squark'
       write(13,102) 5,yukfac(7),'bottom squark'
       end if

      !call filedump(12,13)
      write(13,103)
     &"#--------------------------------------------------#"
      write(13,103) 
     &"# End of SusHi output                              #"
      write(13,103)
     &"#--------------------------------------------------#"

      close(12)
      close(13)

 102  format(1x,I9,3x,1P,E16.8,0P,3x,'#',1x,A)
 1020 format(1x,I9,3x,1P,i2.1,0P,3x,'#',1x,A)
 1021 format(1x,I9,3x,1P,i6.1,0P,3x,'#',1x,A)
 1022 format(1x,I9,3x,1P,A45,0P,3x,'#',1x,A)
 103  format(a)
 105  format('#--------------------------------------------------#')
 106  format ('# Date: ',i2.2,'.',i2.2,'.',i4.4,' at ',
     &i2.2,':',i2.2,':',i2.2,'                     #')
 107  format(9x,1P,E16.8,0P,3x,'#',1x,A)
 1070 format(9x,1P,i2.1,0P,3x,'#',1x,A)
 108  format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)

      end

C-}}}
C-{{{ subroutine screenoutputsushi
      subroutine screenoutputsushi()

      implicit none
      character hepunit*10

      include 'commons/common-inputoutput.f'
      !internal definitions

!defined at other places:
!AlfasMZ,muRfactor,muFfactor,cme,dist,prefix,prefix2,pty,iset
!norder,mw,mc,ew,mz,mbmb,renscheme,mt,pseudo,tanbresum,pseudorap
      include 'commons/common-slha.f'
      include 'commons/common-consts.f'
      include 'commons/common-vars.f'
      include 'commons/common-ren.f'
      include 'commons/common-quark.f'
      include 'commons/common-int.f'

      if ((norderggh.eq.0).and.(ew.ge.1)) then
            write(*,105)
            write(*,*) 
     &"Note: At LO electroweak contributions for ggh are not given."
            write(*,105)
      endif

      if (((dist.ge.1).or.(ptcut.or.rapcut)).and.(ew.eq.2)) then
            write(*,105)
            write(*,*) 
     &"Note: The SM electroweak factor is not applicable"
            write(*,*) "for cuts and distributions."
            write(*,105)
      endif

      if (((dist.eq.1).or.(dist.eq.3).or.(ptcut))) then
            write(*,105)
            write(*,*) 
     &"Note: Fixed order p_T distribution (no resummation)!"
            write(*,*) "p_T < 20 GeV not reasonable."
            write(*,105)
      endif

      if (norderggh.ge.2) then
         if (dist.ne.0) then
            write(*,105)
            write(*,*) 
     &"Note: Differential cross sections for ggh are not available ",
     &"at NNLO."
            write(*,*) 
     &"Thus only NLO results will be given."
            write(*,105)
         elseif (ptcut.or.rapcut) then
            write(*,105)
            write(*,*) 
     &"Note: Cuts can only be applied at NLO for ggh."
            write(*,*) 
     &"Thus NNLO weighted results will not be given."
            write(*,105)
         elseif (model.eq.1) then
            if(norderggh.eq.2) then
               write(*,105)
               write(*,*) 
     &"Note: NNLO SUSY contribution not taken into account."
               write(*,*) 
     &"Use order ggh = 3 for approximate NNLO stop cont. for h."
               write(*,105)
            else
               write(*,105)
               write(*,*) 
     &"Note: Using approximate NNLO top+stop contributions."
               write(*,*) 
            endif
         endif
      endif
      if (norderbbh.ge.0) then
         if (dist.gt.0) then
            write(*,105)
            write(*,*) 
     &"Note: Differential cross sections for bbh are not available."
            write(*,*) 
     &"However cuts for the total cross sections can be set!"
            write(*,105)
         endif
         if ((dist.eq.0).and.(norderbbh.eq.2)) then
         if (ptcut.or.rapcut) then
            write(*,105)
            write(*,*) 
     &"Note: Cuts can only be applied at NLO for bbh."
            write(*,*) 
     &"Thus NNLO results will not be given."
            write(*,105)
         endif
         endif
      end if

      if ((dist.eq.0).or.(dist.eq.2)) then
         hepunit = "   pb"
      else
         hepunit = "   pb/GeV"
      end if

      if (((model.eq.0)).and.(norderbbh.ge.0)) then
         if (dist.eq.0) then
            write(*,105)
            write(*,107) " The bbh-SM results are given by:"
            if ((ptc.eq.0).and.(rapc.eq.0)) then
            write(*,108) "LO: ",SUbbh(1)
            else
            write(*,106) "LO: ",SUbbh(1),SUbbherr(1),hepunit
            end if
            if (norderbbh.gt.0) then
               if ((ptc.eq.0).and.(rapc.eq.0)) then
               write(*,108) "NLO: ",SUbbh(2)
               else
               write(*,106) "NLO: ",SUbbh(2),SUbbherr(2),hepunit
               end if
            end if
            if (norderbbh.gt.1) then
            if (.not.((ptc.gt.0).or.(rapc.gt.0))) then
               write(*,108) "NNLO: ",SUbbh(3)
            end if
            end if
         end if
      end if

      if (((model.eq.1).or.(model.eq.2)).and.(norderbbh.ge.0)) then
         if (dist.eq.0) then
            write(*,105)
            write(*,107) 
     &" The weighted bbh-MSSM/2HDM results are given by:"
            if ((ptc.eq.0).and.(rapc.eq.0)) then
            write(*,108) "LO: ",SUbbhsusy(1)
            else
            write(*,106) "LO: ",SUbbhsusy(1),SUbbhsusyerr(1),hepunit
            end if
            if (norderbbh.gt.0) then
               if ((ptc.eq.0).and.(rapc.eq.0)) then
               write(*,108) "NLO: ",SUbbhsusy(2)
               else
               write(*,106) "NLO: ",SUbbhsusy(2),SUbbhsusyerr(2),hepunit
               end if
            end if
            if (norderbbh.gt.1) then
            if (.not.((ptc.gt.0).or.(rapc.gt.0))) then
               write(*,108) "NNLO: ",SUbbhsusy(3)
            end if
            end if
         end if
      end if

      if (((model.eq.0)).and.(norderggh.ge.0)) then
         write(*,105)
         write(*,107) " The ggh-SM results are given by:"
         write(*,106) "LO: ",CSsm(1),smerr(1),hepunit
         if (norderggh.gt.0) then
            write(*,106) "gg: ",ggsm,ggsmerr,hepunit
            write(*,106) "qg: ",qgsm, qgsmerr,hepunit
            write(*,106) "qq: ",qqsm, qqsmerr,hepunit
            write(*,106) "NLO: ",CSsm(2),smerr(2),hepunit
!            if ((dist.eq.0).and.((ew.ge.1).or.(norderggh.ge.2))) then
            if (((ew.ge.1).or.(norderggh.ge.2))
     &.and.(((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0)).or.(ew.eq.1)))
     & then
            write(*,106) "SM: ",sm,errsm,hepunit
               write(*,107)
     &" Details with respect to the weighted result in output-file."
            end if
         end if
      end if
      if (((model.eq.1).or.(model.eq.2)).and.(norderggh.ge.0)) then
         write(*,105)
         write(*,107) " The ggh-MSSM/2HDM results are given by:"
         write(*,106) "LO: ",CSsusy(1),susyerr(1),hepunit
         if (norderggh.gt.0) then
            write(*,106) "gg: ",ggsusy,ggsusyerr,hepunit
            write(*,106) "qg: ",qgsusy, qgsusyerr,hepunit
            write(*,106) "qq: ",qqsusy, qqsusyerr,hepunit
            write(*,106) "NLO: ",CSsusy(2),susyerr(2),hepunit
!            if ((dist.eq.0).and.((ew.ge.1).or.(norderggh.ge.2))) then
            if (((ew.ge.1).or.(norderggh.ge.2))
     &.and.(((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0)).or.(ew.eq.1)))
     & then
            write(*,106) "MSSM/2HDM: ",mssm,errmssm,hepunit
               write(*,107)
     &" Details with respect to the weighted result in output-file."
            end if
         end if
      end if
      write(*,105)

 105  format('#--------------------------------------------------#')
 106  format(a11,'    ',f10.5,'   +-',f10.5,a10)
 107  format(a)
 108  format(a11,'    ',f10.5, '   pb')

      end
C-}}}
C-{{{ function mapreal8:

      real*8 function mapreal8(val,lval,message)

      implicit real*8(a-z)
      character(*) message
      logical lval

      if (lval) then
         mapreal8 = val
      else
         mapreal8 = -12345678901234567890.d0
         call printdie(message)
      endif

      return
      end

C-}}}
C-{{{ subroutine filedump:

      subroutine filedump(iunitin,iunitout)
c..
c..   Write file unit=iunitin into file unit=iunitout.
c..   Both files must be open before calling filedump,
c..   and both files will be at EOF after calling filedump.
c..
      integer iunitin,iunitout
      character*200 achar

      rewind(iunitin)
 201  read(iunitin,1112,END=202) achar
      length = lnblnk(achar)
      write(iunitout,1112) achar(1:length)
      goto 201
 202  continue

 1112 format(a)

      end

C-}}}
C-{{{ subroutine printdie:

      subroutine printdie(strng)

      character*(*) strng

      write(6,*) 'SusHi (fatal): ',strng,' Stopped.'
      stop

      end

C-}}}
C-{{{ subroutine printcopysushi:

      subroutine printcopysushi(fullflag,iu)

      integer fullflag, iu

      write(iu,1) "#--------------------------------------------------#"
      write(iu,1) "# SusHi: Supersymmetric Higgs production through   #"
      write(iu,1) "#  __      __        gluon fusion and bottom-quark #"
      write(iu,1) "# [_  | | [_  |_| |  annihilation                  #"
      write(iu,1) "# __] |_| __] | | |                                #"
      write(iu,1) "#                    Version 1.1.1, September 2013 #"
      if (fullflag.eq.1) then
      write(iu,1) "#        R. Harlander, S. Liebler, and H. Mantler  #"
      write(iu,1) "#             (harlander@physik.uni-wuppertal.de)  #"
      write(iu,1) "#              (sliebler@physik.uni-wuppertal.de)  #"
      write(iu,1) "#              (hendrik.mantler@uni-wuppertal.de)  #"
      write(iu,1) "#       Bergische Universitaet Wuppertal, Germany  #"
      write(iu,1) "#--------------------------------------------------#"
      write(iu,1) "# SusHi is based on a number of calculations       #"
      write(iu,1) "# due to various groups. Please acknowledge these  #"
      write(iu,1) "# efforts by citing the list of references which   #"
      write(iu,1) "# are included in the output file of every run.    #"
      end if
      write(iu,1) "#--------------------------------------------------#"

 1    format(a)
      
      end

C-}}}
C-{{{ subroutine printwarn:

      subroutine printwarnsushi(unit,strng)

      integer unit
      character*(*) strng

      write(unit,*) 'SusHi (warning): ',strng

      end

C-}}}
C-{{{ subroutine printinfo:

      subroutine printinfosushi(unit,strng)

      integer unit
      character*(*) strng

      write(unit,*) 'SusHi (info): ',strng

      end

C-}}}
C-{{{ subroutine printerror:

      subroutine printerrorsushi(unit,strng)

      integer unit
      character*(*) strng

      write(unit,*) 'SusHi (error): ',strng
      stop

      end

C-}}}
